--------------------------------------------------------------------------------
--                   Zolan's Anchors Away (Main)                               --
--------------------------------------------------------------------------------

if Zolan_AA == nil then Zolan_AA = {} end

local ZAA = Zolan_AA

if ZAA.AddonMenu == nil then ZAA.AddonMenu = {} end
if ZAA.Handler   == nil then ZAA.Handler   = {} end
if ZAA.Util      == nil then ZAA.Util      = {} end
if ZAA.Vars      == nil then ZAA.Vars      = {} end

-- ZO
local ZO_SavedVars = ZO_SavedVars
local d            = d
-- Lua
local pairs        = pairs

function ZAA.loadVariables()
    ---------------------------------------------------
    ---------------------------------------------------
    ----  APP VERSION DO NOT FORGET TO CHANGE!!!!!!! --
    ---------------------------------------------------
    ---------------------------------------------------
    ZAA.appVersion = '1.6'
    ZAA.addonName  = 'Zolan_AnchorsAway'

    ZAA.Vars.savedVariablesName = 'Zolan_AA_SavedVariables'
    ZAA.Vars.configVersion      = 1
    ZAA.Vars.configNamespace    = 'AA'

    ZAA.Vars.headerColor        = "|c88DDFF" -- Light Blue
    ZAA.Vars.defaultColor       = "|cFFFFFF" -- White
    ZAA.Vars.currencyColor      = "|cFFD700" -- Gold

    ZAA.Vars.outputHeader       = ZAA.Vars.headerColor .. "Zolan's Anchors Away:"

    ZAA.Vars.configDefaults = {
        ["configVersion"]      = ZAA.Vars.configVersion,
        ["enabled"]            = true,
        ["notify"]             = true,
        ["showErrors"]         = true,
        ["debug"]              = false
    }

    local profile = nil
    ZAA.savedVars = ZO_SavedVars:New(
        ZAA.Vars.savedVariablesName,
        ZAA.Vars.configVersion,
        ZAA.Vars.configNamespace,
        ZAA.Vars.configDefaults,
        profile
    )

    ZAA.migrateSettings()
    ZAA.defaultMissingSettings()
    ZAA.removeVestigialSettings()

    ZAA.loaded = true
end

function ZAA.migrateSettings()
    -- Nothing for now.
end

function ZAA.defaultMissingSettings()
    for key, value in pairs(ZAA.Vars.configDefaults) do
        if ZAA.savedVars[key] == nil then
            ZAA.savedVars[key] = value
        end
    end
end

function ZAA.removeVestigialSettings()
    for key, value in pairs(ZAA.savedVars) do
        if ZAA.Vars.configDefaults[key] == nil then
            ZAA.savedVars[key] = nil
        end
    end
end

function ZAA.debug(message, isRaw)
    if ZAA.savedVars.debug then
        if isRaw then
            d(message)
        else
            d("ZAA: " .. message)
        end
    end
end
